## far2l 2.5.1~beta+git20230530+ds

=== CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

cmake_minimum_required (VERSION 3.0.2)

project (far2l)

set(APP_NAME "far2l")
set(APP_IDENTIFIER "com.far2l")
set(CPACK_PACKAGE_NAME "far2l")

string(ASCII 27 Esc)
set(ColorNormal "${Esc}[m")
set(ColorRed "${Esc}[1;31m")

include(GNUInstallDirs)

# just to force reconfigure if packaging/version changed
configure_file(${CMAKE_SOURCE_DIR}/packaging/version ${CMAKE_BINARY_DIR}/packaging/version @ONLY)

# reconfigure in case .git directory changed to update version correctly
IF(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS ${CMAKE_SOURCE_DIR}/.git)
endif()

file(READ "${CMAKE_SOURCE_DIR}/packaging/version" VERSION)
string(REGEX REPLACE "[\r\n\t ]$" "" VERSION "${VERSION}")
string(REGEX REPLACE "^([0-9]+)\\..*" "\\1" VERSION_MAJOR "${VERSION}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+).*" "\\1" VERSION_MINOR "${VERSION}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.(.*)" "\\1" VERSION_PATCH "${VERSION}")

if("${VERSION_MAJOR}" STREQUAL "" OR "${VERSION_MAJOR}" STREQUAL "${VERSION}"
    OR "${VERSION_MINOR}" STREQUAL "" OR "${VERSION_MINOR}" STREQUAL "${VERSION}"
    OR "${VERSION_PATCH}" STREQUAL "" OR "${VERSION_PATCH}" STREQUAL "${VERSION}")
        message(FATAL_ERROR "${ColorRed}packaging/version is corrupted, please write actual X.Y.Z version into it.${ColorNormal}")
endif()

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tag
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
        OUTPUT_VARIABLE GIT_TAG
        OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

if(NOT "${GIT_TAG}" STREQUAL "v_${VERSION}")
    if(GIT_FOUND)
        execute_process(COMMAND "${GIT_EXECUTABLE}" rev-parse --short HEAD
            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
            OUTPUT_VARIABLE GIT_HASH
            OUTPUT_STRIP_TRAILING_WHITESPACE)
    endif()
    if(NOT "${GIT_HASH}" STREQUAL "")
        message(STATUS "git hash: ${GIT_HASH}")
        set(VERSION_PATCH "${VERSION_PATCH}-${GIT_HASH}")
    else()
        message(WARNING "git information unavailable, assuming its a build from v_${VERSION}")
    endif()
endif()

set(VERSION_PATCH "${VERSION_PATCH}-beta")

set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Release")
endif()

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE} Version: ${VERSION}")

if(NOT DEFINED CMAKE_INSTALL_PREFIX)
   if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
      set(CMAKE_INSTALL_PREFIX "/usr/local")
   elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
      set(CMAKE_INSTALL_PREFIX "/usr/local")
   else()
      set(CMAKE_INSTALL_PREFIX "/usr")
   endif()
endif()

##############################

if (NOT DEFINED USEWX)
    set(USEWX "YES")
endif()

if (NOT DEFINED UNRAR)
    set(UNRAR "bundled")
endif()

# EACP disabled by default for now as FAR's GetCodePageInfo rejects all multibyte charsets due to BUGBUG.
# Uncomment EACP-stuff here when that will be fixed. See https://github.com/elfmz/far2l/issues/1179
#if (NOT DEFINED EACP)
#   set(EACP "YES")
#endif()

if (NOT DEFINED LEGACY)
    # TODO: default it to NO  somewhere in 2022, after all obsolete settings
    # registry-upgrade-to-ini stuff will be safe to remove
    set(LEGACY "YES")
elseif(FARFTP)
    set(LEGACY "YES")
    message(STATUS "Force-enable LEGACY due to enabled FARFTP")
endif()

#if (NOT EACP)
#   message(STATUS "${ColorRed}Building without East Asian codepages support due to EACP=${EACP}${ColorNormal}")
#endif()

if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    set(M4_NAME gm4)
else()
    set(M4_NAME m4)
endif()

find_program(M4_PROG NAMES ${M4_NAME})

if(NOT M4_PROG)
    message(FATAL_ERROR "${ColorRed}${M4_NAME} not found - please install it${ColorNormal}")
endif ()
set(M4 ${M4_PROG} -P "-DARCH=${CMAKE_SYSTEM_NAME} ${CMAKE_SYSTEM_PROCESSOR}" "-DMAJOR=${VERSION_MAJOR}" "-DMINOR=${VERSION_MINOR}" "-DPATCH=${VERSION_PATCH}")

# set(RM rm) actually not needed: use $(CMAKE_COMMAND) -E remove
find_program (GAWK NAMES gawk)
if(NOT GAWK)
  message(FATAL_ERROR "${ColorRed}gawk not found - please install it${ColorNormal}")
endif ()

if(MUSL)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__MUSL__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__MUSL__")
endif()

if(TAR_LIMITED_ARGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__TAR_LIMITED_ARGS__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__TAR_LIMITED_ARGS__")
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.1.0")
    message("Please consider to switch to newer CMake")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -Wno-unused-function -D_FILE_OFFSET_BITS=64") #  -fsanitize=address
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -std=c99 -fPIC -Wno-unused-function -D_FILE_OFFSET_BITS=64") #  -fsanitize=address
set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS} -O2")
set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS} -O2")

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(APP_DIR ${CMAKE_BINARY_DIR}/install)
    set(INSTALL_DIR ${APP_DIR}/${APP_NAME}.app/Contents/MacOS)
    set(EXECUTABLE_NAME ${APP_NAME})

else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ffunction-sections -fdata-sections")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffunction-sections -fdata-sections")
    set(INSTALL_DIR ${CMAKE_BINARY_DIR}/install)
    set(EXECUTABLE_NAME far2l)

    if (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--gc-sections")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wl,--gc-sections")
    endif()
endif()

if (CMAKE_SYSTEM_NAME MATCHES "CYGWIN")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE=600")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -D_BSD_SOURCE -D_XOPEN_SOURCE=600")
    message(STATUS "Running under cygwin, wow!")
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Haiku")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -D_DEFAULT_SOURCE -Wno-attributes")
endif()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_C_VISIBILITY_PRESET hidden)

if (LEGACY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWINPORT_REGISTRY")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DWINPORT_REGISTRY")
    message(STATUS "Enabling registry support due to enabled LEGACY")
else()
    message(STATUS "LEGACY is not enabled, your old registry settings will be forgotten, if any")
endif()

if(CMAKE_VERSION VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
    cmake_policy(SET CMP0057 NEW)
endif()

include_directories(utils/include)

add_subdirectory (WinPort)
add_subdirectory (utils)
add_subdirectory (far2l)

if (NOT ${USEWX})
    message(STATUS "Building without GUI/wxWidgets backend due to USEWX=${USEWX}")
else()
    message(STATUS "Building with GUI/wxWidgets backend")
    if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
        if (DEFINED wxWidgets_CONFIG_EXECUTABLE)
            message(STATUS "Using pre-defined wx config: ${wxWidgets_CONFIG_EXECUTABLE}")

        elseif(EXISTS "/usr/local/bin/wxgtk3u-3.2-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.2-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.2")
            message(STATUS "Using known location of wx-config 3.2")

        elseif(EXISTS "/usr/local/bin/wxgtk3u-3.1-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.1-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.1")
            message(STATUS "Using known location of wx-config 3.1")

        elseif (EXISTS "/usr/local/bin/wxgtk3u-3.0-config")
            set(wxWidgets_CONFIG_EXECUTABLE "/usr/local/bin/wxgtk3u-3.0-config")
            set(wxWidgets_wxrc_EXECUTABLE "/usr/local/bin/wxrc-gtk3u-3.0")
            message(STATUS "Using known location of wx-config 3.0")

        else()
            message(STATUS "No wxgtk3u-3.*-config in expected locations")
        endif()

    elseif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        if (EXISTS "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wx-config")
            # MacPorts
            set(wxWidgets_CONFIG_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wx-config")
            set(wxWidgets_wxrc_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.2/bin/wxrc")
            message(STATUS "Using known location of wx-config 3.2")

        elseif (EXISTS "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wx-config")
            # MacPorts
            set(wxWidgets_CONFIG_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wx-config")
            set(wxWidgets_wxrc_EXECUTABLE "/opt/local/Library/Frameworks/wxWidgets.framework/Versions/wxWidgets/3.1/bin/wxrc")
            message(STATUS "Using known location of wx-config 3.1")

        else()
            message(STATUS "No wx-config in expected locations")
        endif()
    endif()

    add_subdirectory(WinPort/src/Backend/WX)
endif()

if (NOT DEFINED TTYX)
    find_package(X11)
    if(X11_FOUND)
        message(STATUS "Building with TTY X11 extensions due to X11 found")
        add_subdirectory(WinPort/src/Backend/TTY/TTYX)
    else()
        message(STATUS "Building without TTY X11 extensions due to X11 not found")
    endif()
elseif (TTYX)
    message(STATUS "Building with TTY X11 extensions due to TTYX=${TTYX}")
    add_subdirectory(WinPort/src/Backend/TTY/TTYX)
else()
    message(STATUS "Building without TTY X11 extensions due to TTYX=${TTYX}")
endif()


##############################
# plugins directives

if (NOT DEFINED ALIGN OR ALIGN)
    message(STATUS "ALIGN plugin enabled")
    add_subdirectory (align)
else()
    message(STATUS "${ColorRed}ALIGN plugin disabled due to ALIGN=${ALIGN}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/align/plug/align.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED AUTOWRAP OR AUTOWRAP)
    message(STATUS "AUTOWRAP plugin enabled")
    add_subdirectory (autowrap)
else()
    message(STATUS "${ColorRed}AUTOWRAP plugin disabled due to AUTOWRAP=${AUTOWRAP}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/autowrap/plug/autowrap.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED CALC OR CALC)
    message(STATUS "CALC plugin enabled")
    add_subdirectory (calc)
else()
    message(STATUS "${ColorRed}CALC plugin disabled due to CALC=${CALC}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/calc/plug/calc.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED COLORER OR COLORER)
    message(STATUS "COLORER plugin enabled")
    add_subdirectory (colorer)
else()
    message(STATUS "${ColorRed}COLORER plugin disabled due to COLORER=${COLORER}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/colorer/plug/colorer.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED COMPARE OR COMPARE)
    message(STATUS "COMPARE plugin enabled")
    add_subdirectory (compare)
else()
    message(STATUS "${ColorRed}COMPARE plugin disabled due to COMPARE=${COMPARE}${ColorNormal}")
    install(CODE "
        execute_process(COMMAND ${CMAKE_COMMAND} -E rm -f ${CMAKE_INSTALL_PREFIX}/lib/far2l/Plugins/compare/plug/compare.far-plug-wide)
        " COMPONENT system)
endif()

if (NOT DEFINED DRAWLINE OR DRAWLINE)
    message(STATUS "DRAWLINE plugin enabled")
    add_subdirectory (drawline)
else()

=== NetRocks/CMakeLists.txt ===
project(NetRocks)

set(SOURCES
src/Erroring.cpp
src/Globals.cpp
src/SitesConfig.cpp
src/NetRocks.cpp
src/PluginImpl.cpp
src/PluginPanelItems.cpp
src/PooledStrings.cpp
src/GetItems.cpp
src/BackgroundTasks.cpp
src/Location.cpp
src/ConnectionsPool.cpp
src/ImportFarFtpSites.cpp
src/Host/HostLocal.cpp
src/Host/HostRemote.cpp
src/UI/DialogUtils.cpp
src/UI/Settings/ConfigurePlugin.cpp
src/UI/Settings/SiteConnectionEditor.cpp
src/UI/Settings/ConfigureProtocolFile.cpp
src/UI/Settings/ConfigureProtocolSFTPSCP.cpp
src/UI/Settings/ConfigureProtocolFTP.cpp
src/UI/Settings/ConfigureProtocolSMB.cpp
src/UI/Settings/ConfigureProtocolNFS.cpp
src/UI/Settings/ConfigureProtocolWebDAV.cpp
src/UI/Activities/Confirm.cpp
src/UI/Activities/ConfirmXfer.cpp
src/UI/Activities/ConfirmOverwrite.cpp
src/UI/Activities/ConfirmChangeMode.cpp
src/UI/Activities/SimpleOperationProgress.cpp
src/UI/Activities/ComplexOperationProgress.cpp
src/UI/Activities/AbortOperationRequest.cpp
src/UI/Activities/InteractiveLogin.cpp
src/UI/Activities/ConfirmNewServerIdentity.cpp
src/UI/Activities/WhatOnError.cpp
src/UI/Activities/BackgroundTasksUI.cpp
src/Op/Utils/ProgressStateUpdate.cpp
src/Op/Utils/Enumer.cpp
src/Op/Utils/IOBuffer.cpp
src/Op/OpBase.cpp
src/Op/OpConnect.cpp
src/Op/OpCheckDirectory.cpp
src/Op/OpChangeMode.cpp
src/Op/OpEnumDirectory.cpp
src/Op/OpXfer.cpp
src/Op/OpRemove.cpp
src/Op/OpMakeDirectory.cpp
src/Op/OpExecute.cpp
src/Protocol/SplitLocationSpecification.cpp
src/Protocol/Protocol.cpp
)


set(PROTOCOL_SOURCES
src/Erroring.cpp
src/Host/HostRemoteBroker.cpp
)


add_executable (NetRocks-FILE
    ${PROTOCOL_SOURCES}
    src/Protocol/File/ProtocolFile.cpp
    src/Host/HostLocal.cpp
)

# get rid of warning: dynamic exception specifications are deprecated in C++11
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")

target_link_libraries(NetRocks-FILE utils)
target_include_directories(NetRocks-FILE PRIVATE src)
set_target_properties(NetRocks-FILE
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
    PREFIX ""
    SUFFIX ".broker")
target_compile_options(NetRocks-FILE PUBLIC -DNETROCKS_PROTOCOL)

if (LIBSSH_FOUND AND ((NOT DEFINED NR_SFTP) OR NR_SFTP))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_SFTP")
    add_executable (NetRocks-SFTP
        ${PROTOCOL_SOURCES}
        src/Protocol/SSH/SSHConnection.cpp
        src/Protocol/SSH/ProtocolSFTP.cpp
        src/Protocol/SSH/ProtocolSCP.cpp
    )
    target_link_libraries(NetRocks-SFTP utils ${LIBSSH_LIBRARIES})
    target_include_directories(NetRocks-SFTP PRIVATE src ${LIBSSH_INCLUDE_DIRS})
    set_target_properties(NetRocks-SFTP
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (LIBSMBCLIENT_FOUND AND ((NOT DEFINED NR_SMB) OR NR_SMB))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_SMB")
    add_executable (NetRocks-SMB
        ${PROTOCOL_SOURCES}
        src/Protocol/SMB/ProtocolSMB.cpp
        src/Protocol/SMB/NMBEnum.cpp
    )
    target_link_libraries(NetRocks-SMB utils ${LIBSMBCLIENT_LIBRARIES})
    target_include_directories(NetRocks-SMB PRIVATE src ${LIBSMBCLIENT_INCLUDE_DIRS})
    set_target_properties(NetRocks-SMB
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (LIBNFS_FOUND AND ((NOT DEFINED NR_NFS) OR NR_NFS))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_NFS")
    add_executable (NetRocks-NFS
        ${PROTOCOL_SOURCES}
        src/Protocol/NFS/ProtocolNFS.cpp
    )
    target_link_libraries(NetRocks-NFS utils ${LIBNFS_LIBRARIES})
    target_include_directories(NetRocks-NFS PRIVATE src ${LIBNFS_INCLUDE_DIRS})
    set_target_properties(NetRocks-NFS
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()


if (LIBNEON_FOUND AND ((NOT DEFINED NR_WEBDAV) OR NR_WEBDAV))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_WEBDAV")
    add_executable (NetRocks-WebDAV
        ${PROTOCOL_SOURCES}
        src/Protocol/WebDAV/ProtocolWebDAV.cpp
    )
    target_link_libraries(NetRocks-WebDAV utils ${LIBNEON_LIBRARIES})
    target_include_directories(NetRocks-WebDAV PRIVATE src ${LIBNEON_INCLUDE_DIRS})
    set_target_properties(NetRocks-WebDAV
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

    add_executable (NetRocks-FTP
        ${PROTOCOL_SOURCES}
        src/Protocol/FTP/ProtocolFTP.cpp
        src/Protocol/FTP/FTPConnection.cpp
        src/Protocol/FTP/FTPParseMLST.cpp
        src/Protocol/FTP/FTPParseLIST.cpp
        src/Protocol/DirectoryEnumCache.cpp
    )
    target_link_libraries(NetRocks-FTP utils)
    target_include_directories(NetRocks-FTP PRIVATE src)
if (OPENSSL_FOUND AND ((NOT DEFINED NR_OPENSSL) OR NR_OPENSSL))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_OPENSSL")
    target_link_libraries(NetRocks-FTP ${OPENSSL_LIBRARIES})
    target_include_directories(NetRocks-FTP PRIVATE ${OPENSSL_INCLUDE_DIR})
endif ()
    set_target_properties(NetRocks-FTP
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FAR_HAS_NAMELESS_UNIONS")

add_library (NetRocks MODULE ${SOURCES})

target_link_libraries(NetRocks utils far2l)

target_include_directories(NetRocks PRIVATE src)
target_include_directories(NetRocks PRIVATE ../WinPort)
target_include_directories(NetRocks PRIVATE ../far2l/far2sdk)

target_compile_definitions(NetRocks PRIVATE)

set_target_properties(NetRocks
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

add_custom_command(TARGET NetRocks POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/NetRocks")

=== colorer/CMakeLists.txt ===
project(colorer)


set(LIBCOLORER_TREE "${CMAKE_CURRENT_SOURCE_DIR}/src/Colorer-library/src")

include(src/Colorer-library/cmake/utils.cmake)

colorer_extract_version()
message(STATUS "Build Colorer: ${COLORER_VERSION}")

set(SOURCES
    src/pcolorer2/ChooseTypeMenu.h
    src/pcolorer2/ConsoleAnnotation.h
    src/pcolorer2/FarEditor.h
    src/pcolorer2/FarEditorSet.h
    src/pcolorer2/FarHrcSettings.h
    src/pcolorer2/pcolorer.h
    src/pcolorer2/resource.h
    src/pcolorer2/StringBuffer.h
    src/pcolorer2/tools.h
    src/pcolorer2/ChooseTypeMenu.cpp
    src/pcolorer2/FarEditor.cpp
    src/pcolorer2/FarEditorSet.cpp
    src/pcolorer2/FarHrcSettings.cpp
    src/pcolorer2/pcolorer.cpp
    src/pcolorer2/StringBuffer.cpp
    src/pcolorer2/tools.cpp
)

add_library(colorer MODULE ${SOURCES})

FIND_PACKAGE(Spdlog REQUIRED)
FIND_PACKAGE(XercesC REQUIRED)

# sometimes libstd requires linking to libfmt, sometimes not
# so, if libfmt there - lets link to it, if not - then dont care
FIND_PACKAGE(fmt)

# using fmt_LIBRARY directrly target_link_libraries fails build
# so have to copy it into intermediate var but only if fmt_FOUND
if (fmt_FOUND)
    set(fmt_LIBRARY_OPTIONAL "${fmt_LIBRARY}")
    # add libfmt package into far2l dependencies if needed
    IF(PACKAGE_DEPENDENCIES)
        SET(PACKAGE_DEPENDENCIES "${PACKAGE_DEPENDENCIES}, libfmt${fmt_VERSION_MAJOR}" PARENT_SCOPE)
    ELSE(PACKAGE_DEPENDENCIES)
        SET(PACKAGE_DEPENDENCIES "libfmt${fmt_VERSION_MAJOR}" PARENT_SCOPE)
    ENDIF(PACKAGE_DEPENDENCIES)
else()
    set(fmt_LIBRARY_OPTIONAL "")
endif()

target_include_directories(colorer
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/src/Colorer-library/src
    PUBLIC ${SPDLOG_INCLUDE_DIR}
    PUBLIC ${XERCESC_INCLUDE_DIR}
    )

target_link_libraries(colorer
    ${XERCESC_LIBRARIES}
    ${fmt_LIBRARY_OPTIONAL}
    utils
    colorer_lib
    far2l
    )

set (SPDLOG_DEFINES
    SPDLOG_DISABLE_TID_CACHING
    SPDLOG_NO_THREAD_ID
    SPDLOG_NO_TLS
)

if (NOT EXISTS "${SPDLOG_INCLUDE_DIR}/spdlog/fmt/bundled")
  if (fmt_FOUND)
    set (SPDLOG_DEFINES
        ${SPDLOG_DEFINES}
        SPDLOG_FMT_EXTERNAL=ON
    )
    message("Forcing SPDLOG_FMT_EXTERNAL cuz FMT installed and missing ${SPDLOG_INCLUDE_DIR}/spdlog/fmt/bundled")
  else()
    message("NOT forcing SPDLOG_FMT_EXTERNAL cuz FMT NOT installed")
  endif()
endif()

target_compile_definitions(colorer PUBLIC
    _UNICODE
    UNICODE
    __unix__
    ${SPDLOG_DEFINES}
)

target_include_directories(colorer PRIVATE ${LIBCOLORER_TREE}/src)
target_include_directories(colorer PRIVATE src/pcolorer2)
target_include_directories(colorer PRIVATE src)
target_include_directories(colorer PRIVATE ../WinPort)
target_include_directories(colorer PRIVATE ../far2l/far2sdk)

set_target_properties(colorer
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/colorer/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

add_custom_command(TARGET colorer POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/colorer"
)

add_subdirectory("${LIBCOLORER_TREE}" "${CMAKE_BINARY_DIR}/Colorer-library/src")

=== far2l/CMakeLists.txt ===
project(far2l)

add_subdirectory (bootstrap)

set(SOURCES
src/farversion.cpp
src/cache.cpp
src/clipboard.cpp
src/cmdline.cpp
src/copy.cpp
src/ctrlobj.cpp
src/datetime.cpp
src/delete.cpp
src/dialog.cpp
src/dirinfo.cpp
src/dizlist.cpp
src/DialogBuilder.cpp
src/dlgedit.cpp
src/DlgGuid.cpp
src/edit.cpp
src/editor.cpp
src/EditorConfigOrg.cpp
src/execute.cpp
src/farwinapi.cpp
src/fileattr.cpp
src/fileedit.cpp
src/filefilter.cpp
src/filefilterparams.cpp
src/FilesSuggestor.cpp
src/fileowner.cpp
src/filepanels.cpp
src/filestr.cpp
src/filetype.cpp
src/fileview.cpp
src/findfile.cpp
src/FindPattern.cpp
src/flink.cpp
src/fnparce.cpp
src/foldtree.cpp
src/frame.cpp
src/global.cpp
src/help.cpp
src/hilight.cpp
src/hmenu.cpp
src/Mounts.cpp
src/keybar.cpp
src/main.cpp
src/manager.cpp
src/menubar.cpp
src/message.cpp
src/mkdir.cpp
src/modal.cpp
src/namelist.cpp
src/options.cpp
src/plist.cpp
src/rdrwdsk.cpp
src/RefreshFrameManager.cpp
src/scantree.cpp
src/setattr.cpp
src/setcolor.cpp
src/stddlg.cpp
src/synchro.cpp
src/syslog.cpp
src/TPreRedrawFunc.cpp
src/usermenu.cpp
src/viewer.cpp
src/vmenu.cpp
src/execute_oscmd.cpp
src/ViewerStrings.cpp
src/ViewerPrinter.cpp
src/fileholder.cpp

src/panels/panel.cpp
src/panels/filelist.cpp
src/panels/fldata.cpp
src/panels/flmodes.cpp
src/panels/flplugin.cpp
src/panels/flshow.cpp
src/panels/flupdate.cpp
src/panels/infolist.cpp
src/panels/qview.cpp
src/panels/treelist.cpp

src/console/AnsiEsc.cpp
src/console/keyboard.cpp
src/console/console.cpp
src/console/constitle.cpp
src/console/interf.cpp
src/console/grabber.cpp
src/console/lockscrn.cpp
src/console/palette.cpp
src/console/savescr.cpp
src/console/scrbuf.cpp
src/console/scrobj.cpp
src/console/scrsaver.cpp

src/macro/chgmmode.cpp
src/macro/macro.cpp
src/macro/syntax.cpp
src/macro/tvar.cpp

src/filemask/CFileMask.cpp
src/filemask/FileMasksProcessor.cpp
src/filemask/FileMasksWithExclude.cpp

src/locale/codepage.cpp
src/locale/DetectCodepage.cpp
src/locale/xlat.cpp
src/locale/locale.cpp

src/bookmarks/Bookmarks.cpp
src/bookmarks/BookmarksMenu.cpp
src/bookmarks/BookmarksLegacy.cpp

src/cfg/AllXLats.cpp
src/cfg/config.cpp
src/cfg/ConfigSaveLoad.cpp
src/cfg/ConfigRW.cpp
src/cfg/ConfigLegacy.cpp
src/cfg/HotkeyLetterDialog.cpp
src/cfg/language.cpp

src/hist/history.cpp
src/hist/poscache.cpp

src/plug/plugapi.cpp
src/plug/plugins.cpp
src/plug/PluginW.cpp
src/plug/PluginA.cpp
src/plug/plclass.cpp

src/vt/vtansi.cpp
src/vt/vtshell.cpp
src/vt/vtshell_translation.cpp
src/vt/vtshell_compose.cpp
src/vt/vtshell_leader.cpp
src/vt/vtshell_ioreaders.cpp
src/vt/vtshell_mouse.cpp
src/vt/vtlog.cpp
src/vt/vtcompletor.cpp
src/vt/VTFar2lExtensios.cpp

src/base/InterThreadCall.cpp
src/base/SafeMMap.cpp
src/base/farqueue.cpp
src/base/FARString.cpp
src/base/farrtl.cpp
src/base/DList.cpp

src/mix/format.cpp
src/mix/udlist.cpp
src/mix/cvtname.cpp
src/mix/cddrv.cpp
src/mix/chgprior.cpp
src/mix/MountInfo.cpp
src/mix/dirmix.cpp
src/mix/drivemix.cpp
src/mix/mix.cpp
src/mix/panelmix.cpp
src/mix/pathmix.cpp
src/mix/processname.cpp
src/mix/RegExp.cpp
src/mix/strmix.cpp
src/mix/FSFileFlags.cpp
src/mix/StrCells.cpp
src/mix/ChunkedData.cpp
src/mix/UsedChars.cpp
src/mix/CachedCreds.cpp
)

# Set target names for the executables
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING ${VERSION})
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${VERSION})
    set(MACOSX_BUNDLE_GUI_IDENTIFIER ${APP_IDENTIFIER})
    set(MACOSX_BUNDLE_ICON_FILE "Far.icns")
    set(MACOSX_BUNDLE_BUNDLE_NAME ${APP_NAME})
    add_executable(far2l MACOSX_BUNDLE ${SOURCES} "DE/Far.icns")
    set_target_properties(far2l PROPERTIES
        OUTPUT_NAME ${APP_NAME}
        RUNTIME_OUTPUT_DIRECTORY ${APP_DIR})
    set_source_files_properties("DE/Far.icns" PROPERTIES
        MACOSX_PACKAGE_LOCATION Resources)
else()
    add_executable(far2l ${SOURCES})
    set_target_properties(far2l PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}")
endif()

if (NOT DEFINED USEUCD)
    set(USEUCD "YES")
endif()

if (NOT USEUCD)
    message(STATUS "Building without libuchardet due to USEUCD=${USEUCD}")
else()
    message(STATUS "Building with libuchardet")
    find_package(Uchardet REQUIRED)
    target_compile_definitions(far2l PRIVATE -DUSEUCD)
endif()

target_compile_definitions(far2l PRIVATE -DUNICODE)

target_include_directories(far2l PRIVATE
    .
    far2sdk
    src
    src/base
    src/mix
    src/bookmarks
    src/cfg
    src/console
    src/panels
    src/filemask
    src/hist
    src/locale
    src/macro
    src/plug
    src/vt
    ${CMAKE_CURRENT_BINARY_DIR}
    ${UCHARDET_INCLUDE_DIRS}
    ../WinPort)

add_dependencies(far2l bootstrap WinPort)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    SET (WINPORT -force_load WinPort wineguts utils)
else()
    SET (WINPORT -Wl,--whole-archive WinPort -Wl,--no-whole-archive)
endif()

set_target_properties(far2l
    PROPERTIES
    ENABLE_EXPORTS TRUE)

if (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    target_link_libraries(far2l
    PRIVATE ${WINPORT}
    PRIVATE c
    PRIVATE ${UCHARDET_LIBRARIES})
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Haiku")
    target_link_libraries(far2l
        PRIVATE ${WINPORT}
        PRIVATE gnu
        PRIVATE ${UCHARDET_LIBRARIES})
else()
    target_link_libraries(far2l
    PRIVATE ${WINPORT}
        PRIVATE dl
        PRIVATE ${UCHARDET_LIBRARIES})
endif()

add_custom_command(TARGET far2l POST_BUILD
    COMMAND ln -sf ${EXECUTABLE_NAME} ${INSTALL_DIR}/far2l_askpass
    COMMAND ln -sf ${EXECUTABLE_NAME} ${INSTALL_DIR}/far2l_sudoapp)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
#TODO
else()
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/DE/far2l.desktop" "${CMAKE_CURRENT_BINARY_DIR}/DE/far2l.desktop")

    install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/DE/icons" DESTINATION "share" USE_SOURCE_PERMISSIONS COMPONENT desktop FILES_MATCHING PATTERN "*")

	# Have to make desktop file executable, see:
	# https://wiki.ubuntu.com/SecurityTeam/Policies#Execute-Permission_Bit_Required
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/DE/far2l.desktop" DESTINATION "share/applications" COMPONENT desktop
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
endif()

=== multiarc/CMakeLists.txt ===

project(multiarc)

set(SOURCES
    src/MultiArc.cpp
    src/ArcPlg.cpp
    src/arccfg.cpp
    src/arcget.cpp
    src/arcput.cpp
    src/ArcMix.cpp
    src/ArcProc.cpp
    src/global.cpp
    src/arcread.cpp
    src/arccmd.cpp
    src/formats/ha/ha.cpp
    src/formats/arj/arj.cpp
    src/formats/ace/ace.cpp
    src/formats/arc/arc.cpp
    src/formats/zip/zip.cpp
    src/formats/lzh/lzh.cpp

        src/formats/7z/7z.cpp
        src/formats/7z/7zMain.cpp
        src/formats/7z/C/Lzma86Dec.c
        src/formats/7z/C/7zDec.c
        src/formats/7z/C/Ppmd7Dec.c
        src/formats/7z/C/Sha1.c
        src/formats/7z/C/BraIA64.c
        src/formats/7z/C/Xz.c
        src/formats/7z/C/Lzma2Dec.c
        src/formats/7z/C/AesOpt.c
        src/formats/7z/C/BwtSort.c
        src/formats/7z/C/Bra86.c
        src/formats/7z/C/7zCrcOpt.c
        src/formats/7z/C/7zAlloc.c
        src/formats/7z/C/LzmaLib.c
        src/formats/7z/C/HuffEnc.c
        src/formats/7z/C/7zBuf.c
        src/formats/7z/C/XzDec.c
        src/formats/7z/C/7zBuf2.c
        src/formats/7z/C/Lzma86Enc.c
        src/formats/7z/C/Alloc.c
        src/formats/7z/C/XzCrc64.c
        src/formats/7z/C/XzEnc.c
        src/formats/7z/C/Ppmd8.c
        src/formats/7z/C/Aes.c
        src/formats/7z/C/7zCrc.c
        src/formats/7z/C/Bcj2.c
        src/formats/7z/C/Delta.c
        src/formats/7z/C/7zFile.c
        src/formats/7z/C/Bcj2Enc.c
        src/formats/7z/C/Ppmd8Enc.c
        src/formats/7z/C/LzmaEnc.c
        src/formats/7z/C/Ppmd7Enc.c
        src/formats/7z/C/7zStream.c
        src/formats/7z/C/Ppmd8Dec.c
        src/formats/7z/C/XzCrc64Opt.c
        src/formats/7z/C/LzmaDec.c
        src/formats/7z/C/XzIn.c
        src/formats/7z/C/CpuArch.c
        src/formats/7z/C/LzFind.c
        src/formats/7z/C/Ppmd7.c
        src/formats/7z/C/Lzma2Enc.c
        src/formats/7z/C/Sha256.c
        src/formats/7z/C/Sort.c
        src/formats/7z/C/7zArcIn.c
        src/formats/7z/C/Bra.c
        src/formats/7z/C/Blake2s.c
        src/formats/7z/C/LzFindOpt.c
        src/formats/7z/C/Ppmd7aDec.c
        src/formats/7z/C/Sha1Opt.c
        src/formats/7z/C/Sha256Opt.c

        src/formats/ha/ha/acoder.c
        src/formats/ha/ha/archive.c
        src/formats/ha/ha/asc.c
        src/formats/ha/ha/cpy.c
        src/formats/ha/ha/error.c
        src/formats/ha/ha/ha.c
        src/formats/ha/ha/haio.c
        src/formats/ha/ha/hsc.c
        src/formats/ha/ha/info.c
        src/formats/ha/ha/machine.c
        src/formats/ha/ha/misc.c
        src/formats/ha/ha/swdict.c
)

if("${UNRAR}" STREQUAL "lib")
    set(SOURCES
        ${SOURCES}
        src/formats/rar/rar.cpp
        src/formats/rar/rarmainstub.cpp
    )
elseif(UNRAR)
    set(SOURCES
        ${SOURCES}
        src/formats/rar/rar.cpp
        src/formats/rar/unrar/scantree.cpp
        src/formats/rar/unrar/sha1.cpp
        src/formats/rar/unrar/threadpool.cpp
        src/formats/rar/unrar/crc.cpp
        src/formats/rar/unrar/hash.cpp
        src/formats/rar/unrar/strlist.cpp
        src/formats/rar/unrar/rs16.cpp
        src/formats/rar/unrar/resource.cpp
        src/formats/rar/unrar/consio.cpp
        src/formats/rar/unrar/secpassword.cpp
        src/formats/rar/unrar/qopen.cpp
        src/formats/rar/unrar/recvol.cpp
        src/formats/rar/unrar/rijndael.cpp
        src/formats/rar/unrar/timefn.cpp
        src/formats/rar/unrar/encname.cpp
        src/formats/rar/unrar/rawread.cpp
        src/formats/rar/unrar/file.cpp
        src/formats/rar/unrar/strfn.cpp
        src/formats/rar/unrar/sha256.cpp
        src/formats/rar/unrar/filefn.cpp
        src/formats/rar/unrar/filcreat.cpp
        src/formats/rar/unrar/headers.cpp
        src/formats/rar/unrar/blake2s.cpp
        src/formats/rar/unrar/options.cpp
        src/formats/rar/unrar/volume.cpp
        src/formats/rar/unrar/system.cpp
        src/formats/rar/unrar/crypt.cpp
        src/formats/rar/unrar/cmddata.cpp
        src/formats/rar/unrar/extinfo.cpp
        src/formats/rar/unrar/filestr.cpp
        src/formats/rar/unrar/ui.cpp
        src/formats/rar/unrar/list.cpp
        src/formats/rar/unrar/find.cpp
        src/formats/rar/unrar/smallfn.cpp
        src/formats/rar/unrar/unicode.cpp
        src/formats/rar/unrar/pathfn.cpp
        src/formats/rar/unrar/global.cpp
        src/formats/rar/unrar/rarvm.cpp
        src/formats/rar/unrar/getbits.cpp
        src/formats/rar/unrar/rs.cpp
        src/formats/rar/unrar/errhnd.cpp
        src/formats/rar/unrar/archive.cpp
        src/formats/rar/unrar/dll.cpp
        src/formats/rar/unrar/extract.cpp
        src/formats/rar/unrar/match.cpp
        src/formats/rar/unrar/unpack.cpp
        src/formats/rar/unrar/arcread.cpp
        src/formats/rar/unrar/rdwrfn.cpp
        src/formats/rar/unrar/rarpch.cpp
        src/formats/rar/unrar/rar.cpp
    )
endif()

if(PCRE_FOUND)
    set(SOURCES
        ${SOURCES}
        src/formats/custom/custom.cpp
    )
endif()

if(LibArchive_FOUND)
    set(SOURCES
        ${SOURCES}
        src/formats/libarch/libarch_utils.cpp
        src/formats/libarch/libarch_crutches.cpp
        src/formats/libarch/libarch_cmd_read.cpp
        src/formats/libarch/libarch_cmd_write.cpp
        src/formats/libarch/libarch.cpp
    )
else()
    set(SOURCES
        ${SOURCES}
        src/formats/targz/targz.cpp
        src/formats/cab/cab.cpp

    )
endif()

add_library (multiarc MODULE ${SOURCES})

target_compile_definitions(multiarc PRIVATE -D_7ZIP_ST -D_7ZIP_PPMD_SUPPPORT)

target_link_libraries(multiarc utils far2l)

if(NOT UNRAR)
    message(STATUS "${ColorRed}rar archives support disabled due to UNRAR=${UNRAR}.${ColorNormal}")

elseif("${UNRAR}" STREQUAL "lib")
    message(STATUS "Using system unrar - will need libunrar and unrar tool.")
    find_package(Unrar REQUIRED)
    target_include_directories(multiarc PRIVATE ${UNRAR_INCLUDE_DIR})
    target_compile_definitions(multiarc PRIVATE -DRARDLL -DHAVE_UNRAR)
    target_link_libraries(multiarc ${UNRAR_LIBRARIES})
else()
    message(STATUS "Using bundled unrar sources")
    target_include_directories(multiarc PRIVATE src/formats/rar/unrar)
    target_compile_definitions(multiarc PRIVATE -DRARDLL -DHAVE_UNRAR)
endif()

target_include_directories(multiarc PRIVATE src)
target_include_directories(multiarc PRIVATE src/libpcre)
target_include_directories(multiarc PRIVATE ../WinPort)
target_include_directories(multiarc PRIVATE ../far2l/far2sdk)

if(PCRE_FOUND)
    target_compile_definitions(multiarc PRIVATE -DHAVE_PCRE)
    target_link_libraries(multiarc ${PCRE_LDFLAGS} ${PCRE_LIBRARIES})
    target_include_directories(multiarc PRIVATE ${PCRE_INCLUDE_DIRS})
endif()

if(LibArchive_FOUND)
    target_compile_definitions(multiarc PRIVATE -DHAVE_LIBARCHIVE)
    target_link_libraries(multiarc ${LibArchive_LIBRARIES})
    target_include_directories(multiarc PRIVATE ${LibArchive_INCLUDE_DIRS})
endif()

set_target_properties(multiarc
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/multiarc/plug"
        PREFIX ""
        SUFFIX ".far-plug-mb")

add_custom_command(TARGET multiarc POST_BUILD
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/configs
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/configs "${INSTALL_DIR}/Plugins/multiarc")

=== utils/CMakeLists.txt ===

project(utils)

find_package(PkgConfig REQUIRED)

set(SOURCES
    src/Threaded.cpp
    src/ThreadedWorkQueue.cpp
    src/SharedResource.cpp
    src/KeyFileHelper.cpp
    src/utils.cpp
    src/InstallPath.cpp
    src/StrPrintf.cpp
    src/TimeUtils.cpp
    src/StringConfig.cpp
    src/InMy.cpp
    src/ZombieControl.cpp
    src/base64.cpp
    src/Event.cpp
    src/StackSerializer.cpp
    src/ScopeHelpers.cpp
    src/crc64.c
    src/TTYRawMode.cpp
    src/LocalSocket.cpp
    src/FilePathHashSuffix.cpp
    src/Environment.cpp
    src/Escaping.cpp
    src/WideMB.cpp
    src/FSNotify.cpp
    src/TestPath.cpp
    src/PipeIPC.cpp
    src/PathParts.cpp
    src/CharClasses.cpp
    src/POpen.cpp
    src/VT256ColorTable.cpp
    src/ReadWholeFile.cpp
    src/ThrowPrintf.cpp
    src/FcntlHelpers.cpp
    src/Panic.cpp
    src/IntStrConv.cpp
    src/EnsureDir.cpp
    src/RandomString.cpp
)

add_library (utils STATIC ${SOURCES})


target_include_directories(utils PRIVATE include)

find_package(Threads REQUIRED)
if(THREADS_HAVE_PTHREAD_ARG)
    target_compile_options(utils PUBLIC "-pthread")
endif()
if(CMAKE_THREAD_LIBS_INIT)
    target_link_libraries(utils "${CMAKE_THREAD_LIBS_INIT}")
endif()
if(${CMAKE_SYSTEM_NAME} MATCHES "Haiku")
    target_link_libraries(utils network)
endif()

=== far2l/bootstrap/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.2)

add_custom_target(bootstrap 
    DEPENDS farlang.templ lang.inc
)

message(STATUS "generating headers and languages")

if (CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(LBITS 64)
    set(DIRBIT 64)
else ()
    set(LBITS 32)
    set(DIRBIT 32)
endif ()

set(BOOTSTRAP "${PROJECT_BINARY_DIR}/bootstrap")
set(SCRIPTS "${CMAKE_CURRENT_SOURCE_DIR}/scripts")
set(DEPENDENCIES
    "${SCRIPTS}/tools.m4"
    "${SCRIPTS}/farlang.templ.m4"
)

set(HLFFILES
    "${BOOTSTRAP}/FarEng.hlf"
    "${BOOTSTRAP}/FarRus.hlf"
    "${BOOTSTRAP}/FarHun.hlf"
    "${BOOTSTRAP}/FarUkr.hlf"
)
set(LNGFILES
    "${BOOTSTRAP}/FarEng.lng"
    "${BOOTSTRAP}/FarRus.lng"
    "${BOOTSTRAP}/FarHun.lng"
    "${BOOTSTRAP}/FarUkr.lng"
)

add_custom_command(OUTPUT "${BOOTSTRAP}/farlang.templ"
    COMMAND ${M4} "${SCRIPTS}/farlang.templ.m4" > "${BOOTSTRAP}/farlang.templ"
    WORKING_DIRECTORY "${SCRIPTS}"
    DEPENDS ${DEPENDENCIES}
    COMMENT generating language template
)

add_custom_command(OUTPUT "${BOOTSTRAP}/lang.inc"
    COMMAND perl -I. "${SCRIPTS}/farlng.pl" "${BOOTSTRAP}/farlang.templ" "${BOOTSTRAP}"
    WORKING_DIRECTORY "${SCRIPTS}"
    DEPENDS "${BOOTSTRAP}/farlang.templ"
    COMMENT generating languages
)

add_custom_command(TARGET bootstrap PRE_BUILD
    COMMAND perl -I. "${SCRIPTS}/farver.pl" "${BOOTSTRAP}/farversion.inc" "${CMAKE_SYSTEM_NAME} ${CMAKE_SYSTEM_PROCESSOR}" "${VERSION_MAJOR}" "${VERSION_MINOR}" "${VERSION_PATCH}"
    WORKING_DIRECTORY "${SCRIPTS}"
    COMMENT generating version information
)

add_custom_command(TARGET bootstrap
    COMMAND ${GAWK} -f "${SCRIPTS}/mkhlf.awk" "${SCRIPTS}/FarEng.hlf.m4" | ${M4} > "${BOOTSTRAP}/FarEng.hlf"
    WORKING_DIRECTORY "${SCRIPTS}"
    DEPENDS ${DEPENDENCIES}
    COMMENT generating help eng
)
add_custom_command(TARGET bootstrap
    COMMAND ${GAWK} -f "${SCRIPTS}/mkhlf.awk" "${SCRIPTS}/FarRus.hlf.m4" | ${M4} > "${BOOTSTRAP}/FarRus.hlf"
    WORKING_DIRECTORY "${SCRIPTS}"
    DEPENDS ${DEPENDENCIES}
    COMMENT generating help rus
)
add_custom_command(TARGET bootstrap
    COMMAND ${GAWK} -f "${SCRIPTS}/mkhlf.awk" "${SCRIPTS}/FarHun.hlf.m4" | ${M4} > "${BOOTSTRAP}/FarHun.hlf"
    WORKING_DIRECTORY "${SCRIPTS}"
    DEPENDS ${DEPENDENCIES}
    COMMENT generating help hun
)
add_custom_command(TARGET bootstrap
    COMMAND ${GAWK} -f "${SCRIPTS}/mkhlf.awk" "${SCRIPTS}/FarUkr.hlf.m4" | ${M4} > "${BOOTSTRAP}/FarUkr.hlf"
    WORKING_DIRECTORY "${SCRIPTS}"
    DEPENDS ${DEPENDENCIES}
    COMMENT generating help ukr
)

# older cmake versions does not support copying of multiple files,
# so we use simple stupid /bin/cp and wildcards

add_custom_command(TARGET bootstrap
    POST_BUILD
    DEPENDS "${LNGFILES}"
    COMMAND "cp" "${BOOTSTRAP}/*.lng" "${INSTALL_DIR}"
)

add_custom_command(TARGET bootstrap
    POST_BUILD
    DEPENDS "${HLFFILES}"
    COMMAND "cp" "${BOOTSTRAP}/*.hlf" "${INSTALL_DIR}"
)

add_custom_command(TARGET bootstrap
    POST_BUILD
    COMMAND "cp" "${CMAKE_CURRENT_SOURCE_DIR}/*.sh" "${INSTALL_DIR}"
    COMMAND "cp" "${CMAKE_CURRENT_SOURCE_DIR}/*.ini" "${INSTALL_DIR}"
)

=== WinPort/src/Backend/WX/CMakeLists.txt ===
project(far2l_gui)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    find_program(LSB_RELEASE_EXEC lsb_release)
    execute_process(COMMAND ${LSB_RELEASE_EXEC} -ds
        OUTPUT_VARIABLE LSB_RELEASE
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if (LSB_RELEASE MATCHES "Ubuntu 20|Linux Mint 20")
        add_compile_definitions(WX304PATCH)
    endif()
endif()

set(SOURCES
    Paint.cpp
    CustomDrawChar.cpp
    wxMain.cpp
    wxClipboardBackend.cpp
    ExclusiveHotkeys.cpp
    wxWinTranslations.cpp
    wxConsoleInputShim.cpp
)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(SOURCES
        ${SOURCES}
        Mac/touchbar.mm
        Mac/dockicon.cpp
        Mac/pasteboard.mm
        Mac/hide.mm
    )
endif()

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    find_package(wxWidgets REQUIRED core base adv)
else()
    find_package(wxWidgets REQUIRED core base)
endif()

include(${wxWidgets_USE_FILE})

add_library (far2l_gui MODULE ${SOURCES})

target_include_directories(far2l_gui PRIVATE ..)
target_include_directories(far2l_gui PRIVATE ../..)
target_include_directories(far2l_gui PRIVATE ../../..)
target_include_directories(far2l_gui PRIVATE ../../../../utils/include)
target_include_directories(far2l_gui PRIVATE ${wxWidgets_INCLUDE_DIRS})


#${wxWidgets_CXX_FLAGS}

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    target_link_libraries(far2l_gui utils far2l "-framework IOKit -framework Carbon -framework Cocoa -framework AudioToolbox -framework System -framework OpenGL" ${wxWidgets_LIBRARIES})
else()
    target_link_libraries(far2l_gui utils far2l ${wxWidgets_LIBRARIES})
endif()

set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${wxWidgets_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${wxWidgets_CXX_FLAGS}")

find_package(Threads REQUIRED)
if(THREADS_HAVE_PTHREAD_ARG)
    target_compile_options(far2l_gui PUBLIC "-pthread")
endif()
if(CMAKE_THREAD_LIBS_INIT)
    target_link_libraries(far2l_gui "${CMAKE_THREAD_LIBS_INIT}")
endif()

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set_property (TARGET far2l_gui APPEND_STRING PROPERTY COMPILE_FLAGS "-fobjc-arc")
endif()

find_package(X11)
if(X11_FOUND)
    link_directories(${X11_LIBRARIES})
    include_directories(${X11_INCLUDE_DIR})
    target_link_libraries(far2l_gui ${X11_LIBRARIES})

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__HASX11__")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__HASX11__")
endif()

set_target_properties(far2l_gui
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}"
        PREFIX ""
        SUFFIX ".so")

=== colorer/src/Colorer-library/src/CMakeLists.txt ===
project(colorer_lib)

#====================================================
# colorer
#====================================================
set(SRC_COLORER
    colorer/Common.h
    colorer/Exception.h
    colorer/FileType.h
    colorer/HRCParser.h
    colorer/LineSource.h
    colorer/Region.h
    colorer/RegionHandler.h
    colorer/Scheme.h
    colorer/TextParser.h
    colorer/version.h
    colorer/common/Colorer.cpp
    colorer/common/Colorer.h
    colorer/common/Exception.cpp
    colorer/common/Features.h
    colorer/cregexp/cregexp.cpp
    colorer/cregexp/cregexp.h
    colorer/editor/BaseEditor.cpp
    colorer/editor/BaseEditor.h
    colorer/editor/EditorListener.h
    colorer/editor/OutlineItem.h
    colorer/editor/Outliner.cpp
    colorer/editor/Outliner.h
    colorer/editor/PairMatch.h
    colorer/handlers/LineRegion.h
    colorer/handlers/LineRegionsCompactSupport.cpp
    colorer/handlers/LineRegionsCompactSupport.h
    colorer/handlers/LineRegionsSupport.cpp
    colorer/handlers/LineRegionsSupport.h
    colorer/handlers/RegionDefine.h
    colorer/handlers/RegionMapper.h
    colorer/handlers/RegionMapperImpl.cpp
    colorer/handlers/RegionMapperImpl.h
    colorer/handlers/StyledHRDMapper.cpp
    colorer/handlers/StyledHRDMapper.h
    colorer/handlers/StyledRegion.h
    colorer/handlers/TextHRDMapper.cpp
    colorer/handlers/TextHRDMapper.h
    colorer/handlers/TextRegion.h
    colorer/io/FileInputSource.cpp
    colorer/io/FileInputSource.h
    colorer/io/FileWriter.cpp
    colorer/io/FileWriter.h
    colorer/io/InputSource.cpp
    colorer/io/InputSource.h
    colorer/io/SharedInputSource.cpp
    colorer/io/SharedInputSource.h
    colorer/io/StreamWriter.cpp
    colorer/io/StreamWriter.h
    colorer/io/Writer.cpp
    colorer/io/Writer.h
    colorer/parsers/CatalogParser.cpp
    colorer/parsers/CatalogParser.h
    colorer/parsers/FileTypeChooser.h
    colorer/parsers/FileTypeImpl.cpp
    colorer/parsers/FileTypeImpl.h
    colorer/parsers/HRCParserImpl.cpp
    colorer/parsers/HRCParserImpl.h
    colorer/parsers/HRDNode.h
    colorer/parsers/KeywordList.cpp
    colorer/parsers/KeywordList.h
    colorer/parsers/ParserFactory.cpp
    colorer/parsers/ParserFactory.h
    colorer/parsers/ParserFactoryException.h
    colorer/parsers/SchemeImpl.h
    colorer/parsers/SchemeNode.cpp
    colorer/parsers/SchemeNode.h
    colorer/parsers/TextParserHelpers.cpp
    colorer/parsers/TextParserHelpers.h
    colorer/parsers/TextParserImpl.cpp
    colorer/parsers/TextParserImpl.h
    colorer/parsers/VirtualEntry.h
    colorer/unicode/BitArray.cpp
    colorer/unicode/BitArray.h
    colorer/unicode/CString.cpp
    colorer/unicode/CString.h
    colorer/unicode/Character.cpp
    colorer/unicode/Character.h
    colorer/unicode/CharacterClass.cpp
    colorer/unicode/CharacterClass.h
    colorer/unicode/DString.h
    colorer/unicode/Encodings.cpp
    colorer/unicode/Encodings.h
    colorer/unicode/SString.cpp
    colorer/unicode/SString.h
    colorer/unicode/String.cpp
    colorer/unicode/String.h
    colorer/unicode/UnicodeTools.cpp
    colorer/unicode/UnicodeTools.h
    colorer/unicode/x_charcategory.h
    colorer/unicode/x_charcategory2.h
    colorer/unicode/x_charcategory_names.h
    colorer/unicode/x_defines.h
    colorer/unicode/x_encodings.h
    colorer/unicode/x_tables.h
    colorer/viewer/ParsedLineWriter.h
    colorer/viewer/TextConsoleViewer.cpp
    colorer/viewer/TextConsoleViewer.h
    colorer/viewer/TextLinesStore.cpp
    colorer/viewer/TextLinesStore.h
    colorer/xml/BaseEntityResolver.cpp
    colorer/xml/BaseEntityResolver.h
    colorer/xml/LocalFileXmlInputSource.cpp
    colorer/xml/LocalFileXmlInputSource.h
    colorer/xml/SharedXmlInputSource.cpp
    colorer/xml/SharedXmlInputSource.h
    colorer/xml/XStr.cpp
    colorer/xml/XStr.h
    colorer/xml/XmlInputSource.cpp
    colorer/xml/XmlInputSource.h
    colorer/xml/XmlParserErrorHandler.cpp
    colorer/xml/XmlParserErrorHandler.h
    colorer/xml/XmlTagDefs.h
    )

# Disabled by DCOLORER_FEATURE_JARINPUTSOURCE=FALSE
#    colorer/xml/ZipXmlInputSource.cpp
#    colorer/xml/ZipXmlInputSource.h
#    colorer/io/JARInputSource.cpp
#    colorer/io/JARInputSource.h
#    colorer/io/MemoryFile.cpp
#    colorer/io/MemoryFile.h

# Disabled by COLORER_FEATURE_HTTPINPUTSOURCE=FALSE
#    colorer/io/HTTPInputSource.cpp
#    colorer/io/HTTPInputSource.h

#====================================================
# common flags
#====================================================
set(COLORER_DEF -DNOGDI -DCOLORER_FEATURE_HTTPINPUTSOURCE=FALSE -DCOLORER_FEATURE_JARINPUTSOURCE=FALSE)
if (MSVC)
    set(COLORER_DEF ${COLORER_DEF} -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    # defaut for gcc
    # CMAKE_CXX_FLAGS=
    # CMAKE_CXX_FLAGS_DEBUG= -g
    # CMAKE_CXX_FLAGS_RELEASE= -O3 -DNDEBUG

    # set only new flags
    set(FLAGS_CXX_DEFAULT -fpermissive -Wall)
    set(FLAGS_CXX_RELEASE)
    set(FLAGS_CXX_DEBUG)
elseif (CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    # defaut for msvc
    # CMAKE_C_FLAGS= /DWIN32 /D_WINDOWS
    # CMAKE_C_FLAGS_DEBUG= /MDd /Zi /Ob0 /Od /RTC1
    # CMAKE_C_FLAGS_RELEASE= /MD /O2 /Ob2 /DNDEBUG

    # CMAKE_CXX_FLAGS= /DWIN32 /D_WINDOWS /GR /EHsc
    # CMAKE_CXX_FLAGS_DEBUG= /MDd /Zi /Ob0 /Od /RTC1
    # CMAKE_CXX_FLAGS_RELEASE= /MD /O2 /Ob2 /DNDEBUG

    set(FLAGS_C_DEFAULT /Zi)
    set(FLAGS_C_RELEASE /W3)
    set(FLAGS_C_DEBUG /W4)
    set(FLAGS_CXX_DEFAULT /Zi)
    set(FLAGS_CXX_RELEASE /W3)
    set(FLAGS_CXX_DEBUG /W4)

endif ()

#====================================================
# build
#====================================================

add_library(colorer_lib STATIC ${SRC_COLORER} ${SRC_MALLOC})

FIND_PACKAGE(Spdlog REQUIRED)
FIND_PACKAGE(XercesC REQUIRED)


target_include_directories(colorer_lib
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}
    PUBLIC ${SPDLOG_INCLUDE_DIR}
    PUBLIC ${XERCESC_INCLUDE_DIR}
    )

target_link_libraries(colorer_lib
    PUBLIC ${XERCESC_LIBRARIES}
    ${THREAD_LIBS}
    )

target_compile_definitions(colorer_lib PRIVATE
    ${SPDLOG_DEFINES}
    ${COLORER_DEF}
    __unix__
)

#set_target_properties(colorer_lib PROPERTIES
#    CXX_STANDARD 17
#    CXX_STANDARD_REQUIRED YES
#    CXX_EXTENSIONS NO
#    )

# set options for target
set(MAIN_FLAGS_CXX_DEBUG ${FLAGS_CXX_DEBUG} ${FLAGS_CXX_DEFAULT})
set(MAIN_FLAGS_CXX_RELEASE ${FLAGS_CXX_RELEASE} ${FLAGS_CXX_DEFAULT})
set(MAIN_FLAGS_C_DEBUG ${FLAGS_C_DEBUG} ${FLAGS_C_DEFAULT})
set(MAIN_FLAGS_C_RELEASE ${FLAGS_C_RELEASE} ${FLAGS_C_DEFAULT})

if (${CMAKE_BUILD_TYPE} MATCHES Debug)
    target_compile_options(colorer_lib
        PUBLIC $<$<COMPILE_LANGUAGE:C>:${MAIN_FLAGS_C_DEBUG}>
        PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${MAIN_FLAGS_CXX_DEBUG}>
        )
else ()
    target_compile_options(colorer_lib
        PUBLIC $<$<COMPILE_LANGUAGE:C>:${MAIN_FLAGS_C_RELEASE}>
        PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${MAIN_FLAGS_CXX_RELEASE}>
        )
endif ()

set_target_properties(colorer_lib PROPERTIES
    OUTPUT_NAME "colorer"
    VERSION ${COLORER_VERSION}
    SOVERSION ${COLORER_VERSION_MAJOR}
    DEBUG_POSTFIX "d"
    )
#====================================================
# test
#====================================================

# static analyze
if (COLORER_PVS_STUDIO_CHECK)
    pvs_studio_add_target(TARGET ${PROJECT_NAME}.analyze ALL
        ANALYZE ${PROJECT_NAME}
        MODE GA 64 OP CS
        CFG_TEXT "exclude-path=*/external/*"
        OUTPUT FORMAT errorfile
        LOG ${PROJECT_NAME}.err)
endif ()

=== debian/changelog ===
far2l (2.5.1~beta+git20230530+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <tar@debian.org>  Sun, 11 Jun 2023 12:13:39 +0200

far2l (2.5.1~beta+git20230530+ds-1) experimental; urgency=medium

  * New upstream version.
  * d/copyright: updated file-pattern.

 -- Gürkan Myczko <tar@debian.org>  Tue, 30 May 2023 10:37:48 +0200

=== debian/control ===
Source: far2l
Section: utils
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libsmbclient-dev,
 libneon27-dev,
 libnfs-dev,
 gawk,
 libssh-dev,
 libgnutls28-dev,
 libxi-dev,
 libspdlog-dev (>= 1.9.2+ds),
 libuchardet-dev,
 libxerces-c-dev,
 libarchive-dev,
 libpcre2-dev,
 libssl-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/far2l
Vcs-Git: https://salsa.debian.org/debian/far2l.git
Homepage: https://github.com/elfmz/far2l

Package: far2l
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, far2l-data, chafa, htop
Description: Linux port of FAR v2
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent

Package: far2l-data
Architecture: all
Depends: ${misc:Depends}
Description: Linux port of FAR v2, data files
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent
 .
 This package contains the data files needed to run far2l.
